import type { JSX } from '../../stencil-public-runtime';
import type { DisabledPropType, FocusableElement, HideLabelPropType, HideMsgPropType, HintPropType, IconsHorizontalPropType, InputTypeOnDefault, KolFocusOptions, LabelWithExpertSlotPropType, MsgPropType, NamePropType, OptionsPropType, PlaceholderPropType, RequiredPropType, RowsPropType, ShortKeyPropType, SingleSelectAPI, SingleSelectStates, StencilUnknown, Stringified, SyncValueBySelectorPropType, TooltipAlignPropType, VariantClassNamePropType } from '../../schema';
export declare class KolSingleSelect implements SingleSelectAPI, FocusableElement {
    protected readonly host?: HTMLKolSingleSelectElement;
    protected readonly ctaRef: import("../../utils/element-interaction").CtaRef<HTMLInputElement>;
    private refOptions;
    private readonly translateDeleteSelection;
    private readonly translateNoResultsMessage;
    private oldValue?;
    private clearButtonFocused;
    getValue(): Promise<StencilUnknown>;
    focus(options?: KolFocusOptions): Promise<void>;
    private toggleListbox;
    private onBlur;
    private createEventWithTarget;
    private clearSelection;
    private selectOption;
    private onInput;
    private handleKeyDownDropdown;
    private setFilteredOptionsByQuery;
    private _focusedOptionIndex;
    private moveFocus;
    private focusOption;
    private selectFocusedOption;
    private focusSuggestionStartingWith;
    private getFormFieldProps;
    private getInputProps;
    render(): JSX.Element;
    handleKeyDown(event: KeyboardEvent): void;
    private readonly controller;
    private _isOpen;
    private _filteredOptions?;
    private _inputValue;
    private blockSuggestionMouseOver;
    _accessKey?: string;
    _placeholder?: string;
    _disabled?: boolean;
    _hideMsg?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: IconsHorizontalPropType;
    _label: LabelWithExpertSlotPropType;
    _msg?: Stringified<MsgPropType>;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _options: OptionsPropType;
    _required?: boolean;
    _shortKey?: ShortKeyPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value: StencilUnknown;
    _hasClearButton?: boolean;
    _rows?: RowsPropType;
    _variant?: VariantClassNamePropType;
    state: SingleSelectStates;
    private inputHasFocus;
    constructor();
    private showAsAlert;
    validatePlaceholder(value?: PlaceholderPropType): void;
    validateAccessKey(value?: string): void;
    validateDisabled(value?: DisabledPropType): void;
    validateHideMsg(value?: HideMsgPropType): void;
    validateHideLabel(value?: HideLabelPropType): void;
    validateHint(value?: HintPropType): void;
    validateIcons(value?: IconsHorizontalPropType): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validateOptions(value?: OptionsPropType): void;
    validateRequired(value?: RequiredPropType): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTouched(value?: boolean): void;
    validateValue(value: StencilUnknown): void;
    validateHasClearButton(value?: boolean): void;
    validateRows(value?: number): void;
    validateVariant(value?: VariantClassNamePropType): void;
    handleMouseEvent(): void;
    handleFocusIn(event: FocusEvent): void;
    handleFocusOut(event: FocusEvent): void;
    private updateInputValue;
    componentWillLoad(): void;
    private onChange;
    private onClick;
}
